#!/usr/bin/env ruby

$KCODE="e"

$strPath=File.split(`#{"which rqr.rb"}`.chomp)[0]+"/"
$strBinQr=$strPath+"rqr/qr"
$strZDBAT=`#{"which zdbat"}`.chomp

require 'jcode'
require 'csv'

require 'qte'
require 'qpe'

include Qte
include Qpe

$strDocomo="DoCoMo"
$strAu="AU"
$strVodafone="Vodafone"

$codec = QTextCodec.codecForName("Shift-JIS")
$ecodec = QTextCodec.codecForName("EUC-JP")

$strZen="ĥƥȥʥ˥̥ͥΥϥҥեإޥߥ󥡥礢ĤƤȤʤˤ̤ͤΤϤҤդؤۤޤߤ浪󤡤£ãģţƣǣȣɣʣˣ̣ͣΣϣУѣңӣԣգ֣ףأ٣ڣɡǡʡˡܡΡϡ֡סСѡ"

$strHan='ÎĎŎƎǎȎɎʎˎ͎̎ΎώЎюҎӎԎՎ֎܎ݎ֎ÎĎŎƎǎȎɎʎˎ͎̎ΎώЎюҎӎԎՎ֎܎ݎabcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!\"#$%&\'()~^=+[]{};:*\\|'

$strZenDaku=["","","","","","","","","","","","","","","","","","","",""]
$strHanDaku=["","","","","","","","","","","","","","Î","Ď","ʎ","ˎ","̎","͎","Ύ"]

$chrZero = "0"[0]

class String
  def replaceString
    gsub(/\\/,"\\\\").gsub(/:/,"\\:").gsub(/;/,"\\;").gsub(/,/,"\\,")
  end
  def zen2han
    $strZenDaku.each_with_index do |strOne,i|
       gsub!(strOne,$strHanDaku[i])
    end
    tr($strZen,$strHan)
  end
end

class RqrEnv
  def initialize
  end
  def deviceName
    strDevice = ""
    fp = File.new("/proc/deviceinfo/product","r")
    fp.each do |line|
      strDevice = line
    end
    return strDevice
  end
  def getDesktopWidth
    QApplication.desktop.width
  end
  def getDesktopHeight
    QApplication.desktop.height
  end
  def vgaScreen?
    if getDesktopWidth == 640 or getDesktopHeight== 640 then
      true
    else
      false
    end
  end
  def largeScreen?
    vgaScreen?
  end
  def defaultDialogSize
    if largeScreen? then
      370
    else
      200
    end
  end
end

class RqrConf
  def initialize(strFile = "/home/zaurus/Settings/rqr.conf")
    @strConfFile = strFile
    if $env.getDesktopWidth == 640 then 
      @hDefaultConf = {
        "sizeFont" => "6",
        "sizeMailFont" => "6",
        "sizeAdrsFont" => "3",
        "sizeQr" => "0",
        "bMargin" => "TRUE",
        "pathCurPix" => "/home/zaurus/Documents/rqr.jpeg",
        "pathQrTmp" => "/tmp/qrinput.txt",
        "pathAdrTmp" => "/tmp/qradrinput.txt",
        "lastScreen" => "0",
        "strKeitai" => $strDocomo
      }
    else
      @hDefaultConf = {
        "sizeFont" => "2",
        "sizeMailFont" => "2",
        "sizeAdrsFont" => "2",
        "sizeQr" => "0",
        "bMargin" => "TRUE",
        "pathCurPix" => "/home/zaurus/Documents/rqr.jpeg",
        "pathQrTmp" => "/tmp/qrinput.txt",
        "pathAdrTmp" => "/tmp/qradrinput.txt",
        "lastScreen" => "0",
        "strKeitai" => $strDocomo
      }
    end
    if FileTest.directory?("/home/zaurus/")==false then
      @hDefaultConf["pathCurPix"] ="/home/root/Documents/rqr.jpeg"
    end
    @hConf=@hDefaultConf
    load
  end
  def load
    if FileTest.file?(@strConfFile)==false then
      save
      return @hConf
    end
    fp = File.new(@strConfFile,"r")
    fp.each do |line|
      line = line.chomp
      unless line =~ /^$/
        a = line.split("=",2)
        @hConf[a[0]]=a[1]
      end
    end
    @hDefaultConf.each do |k, v|
      unless @hConf.has_key?(k)
        @hConf[k]=v
      end
    end
    save
    return @hConf
  end
  def getConf
    @hConf
  end
  def setConf(h)
    @hConf=h
    save
  end
  def save
    fp = File.new(@strConfFile,"w")
    @hConf.each do |k, v|
      fp.print(k + "=" + v + "\n")
    end
    fp.close
  end
end

class RqrSetPixSizeDialog < QDialog
  def initialize
    super(nil, "RqrSetPixSizeDialog", true) # Modal Dialog
    setCaption(tr(""))
    vb=QVBox.new(self)
    if $env.largeScreen? then
      vb.setFixedSize(200,120)
    else
      vb.setFixedSize(100,100)
    end
      @ckAuto=QCheckBox.new(tr("ưĴ"),vb)
      QLabel.new(tr("åʤ硢"),vb)
      QLabel.new(tr("ꤷޤ"),vb)
      hb=QHBox.new(vb)
        @sbSize=QSpinBox.new(hb)
        QLabel.new(tr("ԥ"),hb)
        @sbSize.setMinValue(0)
        @sbSize.setMaxValue($env.defaultDialogSize)
      @ckMargin=QCheckBox.new(tr("ޡ"),vb)
      connect(@ckAuto,QSIGNAL("stateChanged(int)"),self,"tglCheck(i)")
  end
  def exec
    h=$conf.getConf
    if h["sizeQr"]=="0" then
      @ckAuto.setChecked(true)
      @sbSize.setValue(100)
      @sbSize.setEnabled(false)
    else
      @ckAuto.setChecked(false)
      @sbSize.setValue(h["sizeQr"].to_i)
      @sbSize.setEnabled(true)
    end
    if h["bMargin"]=="TRUE" then
      @ckMargin.setChecked(true)
    else
      @ckMargin.setChecked(false)
    end
    super
  end
  def getConf
    h=$conf.getConf
    if @ckAuto.isChecked then
      h["sizeQr"]="0"
    else
      h["sizeQr"]=@sbSize.value.to_s
    end
    if @ckMargin.isChecked then
      h["bMargin"]="TRUE"
    else
      h["bMargin"]="FALSE"
    end
    h
  end
  def tglCheck(i)
    case i
    when 0
      @sbSize.setEnabled(true)
    when 2
      @sbSize.setEnabled(false)
    end
  end
end

class RqrDialog < QDialog
  def initialize
    super(nil, "RqrDialog", true) # Modal Dialog
    setFixedSize($env.defaultDialogSize,$env.defaultDialogSize)
    setCaption(tr("RQR"))
    @qrCanvas=RqrCanvas.new(self)
    @qrCanvas.setFixedSize(size)
  end
  def getCanvas
    @qrCanvas
  end
end

class RqrCanvas < QWidget
  def initialize(parent)
    super(parent)
    setPalette(QPalette.new(QColor.new(255,255,255)))
    @strQr=""
    @qpBuf=QPixmap.new(size)
    @qpBuf.fill(QColor.new(255,255,255))
    @p=QPainter.new
    catchEvent
  end
  def drawQr(strQr)
    @strQr=strQr
    if @strQr!="" then
      astrQr = @strQr.split(/\n/)
      h=$conf.getConf

      if h["bMargin"]=="TRUE" then
        strVMargin = "0" * (astrQr.length + 12)
        astrQr.collect! {|strOne|
          "000000" + strOne + "000000"
        }
        astrQr.unshift(strVMargin)
        astrQr.unshift(strVMargin)
        astrQr.unshift(strVMargin)
        astrQr.unshift(strVMargin)
        astrQr.unshift(strVMargin)
        astrQr.unshift(strVMargin)
        astrQr.push(strVMargin)
        astrQr.push(strVMargin)
        astrQr.push(strVMargin)
        astrQr.push(strVMargin)
        astrQr.push(strVMargin)
        astrQr.push(strVMargin)
      end

      widthQr = astrQr[0].length

      h=$conf.getConf

      if h["sizeQr"]=="0" then

        s=widthQr*$iBlock
        i=$iBlock
        j=$iBlock
        if s>height then
          i=height.to_f/widthQr.to_f
          j=i.ceil
          s=widthQr*i
        end
        if s>width then
          i=width.to_f/widthQr.to_f
          j=i.ceil
          s=widthQr*i
        end

      else

        s=h["sizeQr"].to_i
        i=s.to_f/widthQr.to_f
        j=i.ceil

      end

      @qpBuf.resize(s,s)

      @qpBuf.fill(QColor.new(255,255,255))
      @p.begin(@qpBuf)
      @p.setBrush(QColor.new(0,0,0))
      @p.setPen(SolidLine)

      y = 0
      while y < widthQr
        strOne = astrQr[y]
        x = 0
        while x < widthQr
          if strOne[x]!=$chrZero then
            @p.drawRect(x*i, y*i, j, j)
          end
          x += 1
        end
        y += 1
      end
      @p.end
      h=$conf.getConf
      @qpBuf.save(h["pathCurPix"],"JPEG")
    end
  end
  def paintEvent(e)
    bitBlt(self,width/2 - @qpBuf.width/2, height/2 - @qpBuf.height/2 ,@qpBuf)
  end
end

class RqrEdit < QMultiLineEdit
  def initialize(p, confKey="sizeFont")
    super(p)
    setWordWrap(WidgetWidth)
    setWrapPolicy(Anywhere)

    if FileTest.directory?("/home/zaurus/") then
      @aFontSize=[10,12,16,18,20,24,36,48,72]
    else
      @aFontSize=[10,12,16,18,20,24]
    end
    @confKey=confKey
    setupFontSize
    catchEvent
  end

  def setupFontSize
    hConf=$conf.getConf
    setFont(QFont.new("lcfont",@aFontSize[hConf[@confKey].to_i]))
  end

  def updownFont(i)
    hConf=$conf.getConf
    j=hConf[@confKey].to_i + i
    if j < 0 or j >= @aFontSize.size then
      return
    end
    hConf[@confKey]=j.to_s
    $conf.setConf(hConf)
    setupFontSize
  end

  def keyPressEvent(e)
    case e.key
    when Qt::Key_Tab
      $frmMain.execQr
      e.ignore
    when 4154
      $frmMain.setFocus2Menu
      e.ignore
    end
  end

  def getData
    h = $conf.getConf
    case h["strKeitai"]
    when $strDocomo
      $codec.fromUnicode(self.text).data.gsub(/\n/,"\r\n").replaceString
    when $strVodafone, $strAu
      $codec.fromUnicode(self.text).data.gsub(/\n/," ")
    end
  end

end

class RqrMailto < QVBox
  def initialize(p)
    super(p)
    h1=QHBox.new(self)
      QLabel.new(tr("衧"),h1)
      @leTo = QLineEdit.new(h1)
    h2=QHBox.new(self)
      QLabel.new(tr("ɽꡧ"),h2)
      @leSubject = QLineEdit.new(h2)
    @confKey="sizeMailFont"
    @meBody = RqrEdit.new(self,@confKey)
    if $strZDBAT!="" and $env.deviceName!="SL-A300" then
      @btnAdrs = QPushButton.new(tr("ɥ쥹Ģ"),h1)
      connect(@btnAdrs,QSIGNAL("clicked()"),self,"selectAddress")
    end
  end

  def updownFont(i)
    @meBody.updownFont(i)
  end

  def getData
    h=$conf.getConf
    case h["strKeitai"]

    when $strDocomo
      strTo = $codec.fromUnicode(@leTo.text).data.replaceString
      strSubject = $codec.fromUnicode(@leSubject.text).data.replaceString
      strBody = @meBody.getData
      "MATMSG:TO:" + strTo + ";SUB:" + strSubject + ";BODY:" + strBody + ";;"

    when $strVodafone, $strAu
      strTo = $codec.fromUnicode(@leTo.text).data
      strSubject = $codec.fromUnicode(@leSubject.text).data
      strBody = @meBody.getData
      "MAILTO:" + strTo + "\r\nBODY:" + strBody + "\r\nSUBJECT:" + strSubject + "\r\n"
    end

  end

  def selectAddress
    if $adrsDialog.exec != 0 then
      strTo = $adrsDialog.addressMail
      astrTo = strTo.split(" ")
      if astrTo.size > 1 then
        $mailDialog.setMail(astrTo)
        if $mailDialog.exec != 0 then
          strTo = $mailDialog.getMail
        else
          strTo = ""
        end
      end
      if strTo != "" then
        strCur = @leTo.text.utf8.data
        if strCur == "" then
          @leTo.setText(tr(strTo))
        else
          @leTo.setText(tr(strCur + ", " + strTo))
        end
      end
    end
  end
end

class RqrAddress < QVBox
  def initialize(p)
    super(p)
    sv = QScrollView.new(self)

#    sv.setHScrollBarMode(QScrollView::AlwaysOff)

    vb = QVBox.new(sv)
    sv.addChild(vb)


    if $env.getDesktopWidth > $env.getDesktopHeight then
      vb.setFixedWidth($tab.sizeHint.width-sv.verticalScrollBar.sizeHint.width-sv.sizeHint.width)
    else

#TODO TabWidget  TabBar ǤOK?Ȥꤢᤦ

      vb.setFixedWidth($tab.sizeHint.height+142-sv.verticalScrollBar.sizeHint.height-sv.sizeHint.height-10)

    end

    @pCont=nil
    h=QHBox.new(vb)
      QLabel.new(tr("̾"),h)
      @leLname = QLineEdit.new(h)
      QLabel.new(tr("̾"),h)
      @leFname = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr("̎؎ގ "),h)
      @leLfurigana = QLineEdit.new(h)
      QLabel.new(tr("̾"),h)
      @leFfurigana = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr("á"),h)
      @leTel1 = QLineEdit.new(h)
      QLabel.new(tr(""),h)
      @leTel2 = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr("Mail1 "),h)
      @leEmail1 = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr("Mail2 "),h)
      @leEmail2 = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr("Mail3 "),h)
      @leEmail3 = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr("Memo"),h)
      @leMemo = RqrEdit.new(h,"sizeAdrsFont")
      @leMemo.setFixedHeight(($iFont+3)*4)

    h=QHBox.new(vb)
      QLabel.new(tr("*URL"),h)
      @leHP = QLineEdit.new(h)

    h=QHBox.new(vb)
      QLabel.new(tr("* "),h)
      @leAdrCountry = QLineEdit.new(h)
      QLabel.new(tr(""),h)
      @leAdrZip = QLineEdit.new(h)
      QLabel.new(tr("ƻܸ"),h)
      @leAdrPref = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr("Į¼"),h)
      @leAdrCity = QLineEdit.new(h)
    h=QHBox.new(vb)
      QLabel.new(tr(""),h)
      @leAdrBanchi = RqrEdit.new(h,"sizeAdrsFont")
      @leAdrBanchi.setFixedHeight(($iFont+3)*4)
    h=QHBox.new(vb)
      QLabel.new(tr("ֹ"),h)
      @leAdrHeya = QLineEdit.new(h)
      QLabel.new(tr("Ȣ"),h)
      @leAdrShisho = QLineEdit.new(h)

    if $strZDBAT!="" and $env.deviceName!="SL-A300" then
      h=QHBox.new(self)
        @btnPrev = QPushButton.new(tr(""),h)
        @btnAdrs = QPushButton.new(tr("ɥ쥹Ģ"),h)
        @btnNext = QPushButton.new(tr(""),h)
        @btnClear = QPushButton.new(tr("ꥢ"),h)
        @ckZap=QCheckBox.new(tr("Ϣ³Ѵ⡼"),h)
      connect(@btnPrev,QSIGNAL("clicked()"),self,"prevAddress") 
      connect(@btnAdrs,QSIGNAL("clicked()"),self,"selectAddress") 
      connect(@btnNext,QSIGNAL("clicked()"),self,"nextAddress") 
      connect(@btnClear,QSIGNAL("clicked()"),self,"clearAll") 
    end
    catchEvent
  end

  def updownFont(i)
    @leMemo.updownFont(i)
    @leAdrBanchi.updownFont(i)
  end

  def selectAddress
    if $adrsDialog.exec != 0 then
      showAddress($adrsDialog.addressAll)
    end
  end

  def isZapMode?
    if $strZDBAT!="" and $env.deviceName!="SL-A300" then
      @ckZap.isChecked
    else
      false
    end
  end

  def eofAddress?
    if $adrsDialog.ready? then
      $adrsDialog.eofAddress?
    else
      false
    end
  end

  def nextAddress
    if !$adrsDialog.ready? then
      $frmMain.setCaption(tr("RQR...ɥ쥹Ģ..."))
      @pCont = Proc.new {
        $adrsDialog.makeList
        $frmMain.setCaption(tr("RQR"))
        showAddress($adrsDialog.addressAll)
      }
      startTimer(0)
    else
      showAddress($adrsDialog.nextAddressAll)
    end
  end

  def prevAddress
    if !$adrsDialog.ready? then
      $frmMain.setCaption(tr("RQR...ɥ쥹Ģ..."))
      @pCont = Proc.new {
        $adrsDialog.makeList
        $frmMain.setCaption(tr("RQR"))
        showAddress($adrsDialog.addressAll)
      }
      startTimer(0)
    else
      showAddress($adrsDialog.prevAddressAll)
    end
  end

  def timerEvent(e)
    killTimers
    @pCont.call
  end

  def showAddress(hAdrs)
    if hAdrs==nil then 
      return
    end
    @leLname.setText(tr(hAdrs[2]))
    @leFname.setText(tr(hAdrs[3]))
    @leLfurigana.setText(tr(hAdrs[4]))
    @leFfurigana.setText(tr(hAdrs[5]))
    @leTel1.setText(tr(hAdrs[7]))
    @leTel2.setText(tr(hAdrs[8]))
    astrMail=hAdrs[6].split(" ",3)
    if astrMail[0]==nil then
      astrMail[0]=""
    end
    if astrMail[1]==nil then
      astrMail[1]=""
    end
    if astrMail[2]==nil then
      astrMail[2]=""
    end
    @leEmail1.setText(tr(astrMail[0]))
    @leEmail2.setText(tr(astrMail[1]))
    @leEmail3.setText(tr(astrMail[2]))
    @leHP.setText(tr(hAdrs[9]))
    @leAdrCountry.setText(tr(hAdrs[10]))
    @leAdrZip.setText(tr(hAdrs[11]))
    @leAdrPref.setText(tr(hAdrs[12]))
    @leAdrCity.setText(tr(hAdrs[13]))
    @leAdrBanchi.setText(tr(hAdrs[14]))
    @leAdrHeya.setText("")
    @leAdrShisho.setText("")
    @leMemo.setText(tr(hAdrs[15].gsub(/\r\n/,"\n")))

  end

  def clearAll()
    @leLname.setText("")
    @leFname.setText("")
    @leLfurigana.setText("")
    @leFfurigana.setText("")
    @leTel1.setText("")
    @leTel2.setText("")
    @leEmail1.setText("")
    @leEmail2.setText("")
    @leEmail3.setText("")
    @leHP.setText("")
    @leAdrCountry.setText("")
    @leAdrZip.setText("")
    @leAdrPref.setText("")
    @leAdrCity.setText("")
    @leAdrBanchi.setText("")
    @leAdrHeya.setText("")
    @leAdrShisho.setText("")
    @leMemo.setText("")
  end

  def getData
    h=$conf.getConf
    case h["strKeitai"]
    when $strDocomo
      strLname = $codec.fromUnicode(@leLname.text).data.replaceString
      strFname = $codec.fromUnicode(@leFname.text).data.replaceString
      strLfurigana = $codec.fromUnicode(@leLfurigana.text).data.replaceString
      strFfurigana = $codec.fromUnicode(@leFfurigana.text).data.replaceString
      strTel1 = $codec.fromUnicode(@leTel1.text).data.replaceString
      strTel2 = $codec.fromUnicode(@leTel2.text).data.replaceString
      strEmail1 = $codec.fromUnicode(@leEmail1.text).data.replaceString
      strEmail2 = $codec.fromUnicode(@leEmail2.text).data.replaceString
      strEmail3 = $codec.fromUnicode(@leEmail3.text).data.replaceString
      strHP = $codec.fromUnicode(@leHP.text).data.replaceString
      strAdrCountry = $codec.fromUnicode(@leAdrCountry.text).data.replaceString
      strAdrZip = $codec.fromUnicode(@leAdrZip.text).data.replaceString
      strAdrPref = $codec.fromUnicode(@leAdrPref.text).data.replaceString
      strAdrCity = $codec.fromUnicode(@leAdrCity.text).data.replaceString
      strAdrBanchi = @leAdrBanchi.getData
      strAdrHeya = $codec.fromUnicode(@leAdrHeya.text).data.replaceString
      strAdrShisho = $codec.fromUnicode(@leAdrShisho.text).data.replaceString

      strMemo = @leMemo.getData

      strQr = "MECARD:N:" + strLname + "," + strFname + ";SOUND:" + strLfurigana + "," + strFfurigana + ";TEL:" + strTel1 + ";TEL:" + strTel2
      strQr << ";EMAIL:" + strEmail1 + ";EMAIL:" + strEmail2 + ";EMAIL:" + strEmail3 + ";URL:" + strHP
      strQr << ";NOTE:" + strMemo
      strQr << ";ADR:" + strAdrShisho + "," + strAdrHeya + ","  + strAdrBanchi + "," + strAdrCity + "," + strAdrPref + "," + strAdrZip  + "," + strAdrCountry  + ";;"

    when $strVodafone, $strAu
      strLname = $codec.fromUnicode(@leLname.text).data
      strFname = $codec.fromUnicode(@leFname.text).data

      strLfurigana = $codec.fromUnicode($ecodec.toUnicode($ecodec.fromUnicode(@leLfurigana.text).data.zen2han)).data
      strFfurigana = $codec.fromUnicode($ecodec.toUnicode($ecodec.fromUnicode(@leFfurigana.text).data.zen2han)).data

      strTel1 = $codec.fromUnicode(@leTel1.text).data
      strTel2 = $codec.fromUnicode(@leTel2.text).data
      strEmail1 = $codec.fromUnicode(@leEmail1.text).data
      strEmail2 = $codec.fromUnicode(@leEmail2.text).data
      strEmail3 = $codec.fromUnicode(@leEmail3.text).data
      strMemo = @leMemo.getData

      strQr =  "MEMORY:" + strMemo
      strQr << "\r\nNAME1:" + strLname + strFname + "\r\nNAME2:" + strLfurigana + strFfurigana 
      strQr << "\r\nMAIL1:" + strEmail1 + "\r\nMAIL2:" + strEmail2 + "\r\nMAIL3:" + strEmail3 
      strQr << "\r\nTEL1:" + strTel1 + "\r\nTEL2:" + strTel2

      if h["strKeitai"]==$strAu then
        strAdrPref = $codec.fromUnicode(@leAdrPref.text).data
        strAdrCity = $codec.fromUnicode(@leAdrCity.text).data
        strAdrBanchi = @leAdrBanchi.getData
        strQr << "\r\nADD:" + strAdrPref + strAdrCity + strAdrBanchi
      end

      strQr << "\r\n"

    end

    strQr
  end

end

class FormMain < QMainWindow
  def initialize
    super
    setCaption("RQR")
    @idMail = 0
    @idAdrs = 1
    @idText = 2
    vb=QVBox.new(self)
      @tab = QTabWidget.new(vb)
      $tab = @tab

        @rqMail = RqrMailto.new(@tab)
        @tab.insertTab(@rqMail,tr("Mail"),@idMail)
        @rqAdrs = RqrAddress.new(@tab)
        @tab.insertTab(@rqAdrs,tr("Address"),@idAdrs)
        @leStr = RqrEdit.new(@tab)
        @tab.insertTab(@leStr,tr("Text"),@idText)
      @atab=[@rqMail,@rqAdrs,@leStr]
    h=$conf.getConf
    @tab.setCurrentPage(h["lastScreen"].to_i)
    @btnExec = QPushButton.new(tr("QRɤѴ"),vb)
    setCentralWidget(vb)

    @strLastData=""
    @strLastQr=""
    @strLastSize=""
    @strLastMargin=""
    @strLastPhone=""
    @bNextQr=nil
    @bRealZap=false
    @aiVMax = [-1,14,26,42,62,84,106,122,152,180,213,251,287,331,362,412,450,504,460,624,666,711,779,857,911,997,1059,1125,11901,1264,1370,1452,1538,1628,1722,1809,1911,1989,2099,2213,2331]
    @hMenuId=Hash.new
    @mbar=QMenuBar.new(self)
    @hPop=Hash.new
    ["ե","ե",""].each do |e|
      @hPop[e]=QPopupMenu.new
      @mbar.insertItem(tr(e),@hPop[e])
    end
    p=@hPop["ե"]
    @hMenuId["setPixPath"]=p.insertItem(tr("ե¸ѹ"))
    @hMenuId["setPixSize"]=p.insertItem(tr("ѹ"))
    @hMenuId["execQr"]=p.insertItem(tr("QRɤѴ"))
    p=@hPop["ե"]
    @hMenuId["upFontSize"]=p.insertItem(tr("ä礭"))
    @hMenuId["downFontSize"]=p.insertItem(tr("äȾ"))
    p=@hPop[""]
    @hMenuId["setDocomo"]=p.insertItem($strDocomo)
    @hMenuId["setAu"]=p.insertItem($strAu)
    @hMenuId["setVodafone"]=p.insertItem($strVodafone)
    @aMenuIdKeitai=[@hMenuId["setDocomo"],@hMenuId["setVodafone"]]
    @aMenuIdKeitai=[@hMenuId["setDocomo"],@hMenuId["setAu"],@hMenuId["setVodafone"]]
    p.setCheckable(true)

    h=$conf.getConf
    setKeitai(h["strKeitai"])

    connect(@btnExec,QSIGNAL("clicked()"),self,"execQr")
    connect(@hPop["ե"],QSIGNAL("activated(int)"),self,"activateMenu(id)")
    connect(@hPop["ե"],QSIGNAL("activated(int)"),self,"activateMenu(id)")
    connect(@hPop[""],QSIGNAL("activated(int)"),self,"activateMenu(id)")
    catchEvent
  end

  def activateMenu(id)
    case id
    when @hMenuId["execQr"]
      execQr
    when @hMenuId["upFontSize"]
      updownFont(1)
    when @hMenuId["downFontSize"]
      updownFont(-1)
    when @hMenuId["setPixSize"]
      if $sizeDialog.exec !=0 then
        $conf.setConf($sizeDialog.getConf)
      end
    when @hMenuId["setPixPath"]
      selectFileName
    when @hMenuId["setDocomo"]
      setKeitai($strDocomo)
    when @hMenuId["setAu"]
      setKeitai($strAu)
    when @hMenuId["setVodafone"]
      setKeitai($strVodafone)
    end
  end


  def setKeitai(strKeitai)
    p=@hPop[""]
    @aMenuIdKeitai.each do |id|
      p.setItemChecked(id,p.text(id).utf8.data==strKeitai)
    end
    h=$conf.getConf
    h["strKeitai"]=strKeitai
    $conf.setConf(h)
  end


  def updownFont(i)
    @atab[@tab.currentPageIndex].updownFont(i)
  end

  def selectFileName
    h = $conf.getConf
    if $fileDialog.showDialog(h["pathCurPix"]) !=0 then
      h["pathCurPix"]=$fileDialog.getSelectedFile
      $conf.setConf(h)
    end
  end

  def setFocus2Menu
    @mbar.setFocus
  end

  def execQr
    w = @tab.currentPageIndex
    case w
    when @idText
      execQrMain
    when @idMail
      execQrMain
    when @idAdrs
      if @rqAdrs.isZapMode? then
        case QMessageBox::warning(self, tr("Ϣ³Ѵ¹Ԥޤ"), tr("[Ϣ³Ѵ⡼]ꤵƤޤ\n[Ϣ³Ѵ⡼]ǤϡߤϥǡѴλ塢\n[] 졢\nɥ쥹Ģǡ֤Ѵޤ\nλˤ QRɽ\n[Cancel] 򲡤Ƥ\n[Ϣ³Ѵ]⡼ɤǼ¹Ԥޤ"), QMessageBox::Yes , QMessageBox::No | QMessageBox::Default)
        when QMessageBox::Yes
          execZapMode
        when QMessageBox::No
          QMessageBox::warning(self, tr("̤Ѵ"), tr("ɽƤǡΤѴޤ"), QMessageBox::Ok | QMessageBox::Default)
          @realZapMode=false
          execQrMain
        end
      else
        execQrMain
      end
    end
  end

  def execZapMode
    @realZapMode=true
    $rqrDialog.setCaption(tr("³:[OK]λ:[Cancel]"))
    execQrMain
  end

  def execZapModeCont
    if @bNextQr!=0 then 
      unless @rqAdrs.eofAddress?
        @rqAdrs.nextAddress
        execQrMain
      end
    else
      @realZapMode=false
      $rqrDialog.setCaption(tr("RQR"))
    end
  end

  def execQrMain
    strData=@atab[@tab.currentPageIndex].getData
    
    h=$conf.getConf

    if strData==@strLastData and h["sizeQr"]==@strLastSize and h["bMargin"]==@strMargin and @h["strKeitai"]==@strLastPhone then
        @bNextQr = $rqrDialog.exec
        if @realZapMode then
          @pCont = Proc.new {
            execZapModeCont
          }
          startTimer(0)
        end

    elsif strData==@strLastData and (h["sizeQr"]!=@strLastSize or h["bMargin"]!=@strMargin or h["strKeitai"]!=@strLastPhone) then
        @strLastSize=h["sizeQr"]
        @strLastMargin=h["bMargin"]
        @strLastPhone=h["strKeitai"]

        $rqrCanvas.drawQr(@strLastQr)

        @bNextQr = $rqrDialog.exec
        if @realZapMode then
          @pCont = Proc.new {
            execZapModeCont
          }
          startTimer(0)
        end

    else
      setCaption(tr("RQR Ѵ..."))
      @pCont = Proc.new {
        @strLastData=strData
        @strLastSize=h["sizeQr"]
        @strLastMargin=h["bMargin"]
        @strLastPhone=h["strKeitai"]

        iLen = strData.size
        iVer = 0
        (1..@aiVMax.size-1).each do |i|
          if @aiVMax[i] > iLen then
            iVer = i
            break
          end
        end
        
        h=$conf.getConf
        
        fp = File.new(h["pathQrTmp"],"w")
        fp.print(strData)
        fp.close

        @strLastQr=`#{ $strBinQr + " -v" + iVer.to_s + " -m8 -eM < " + h["pathQrTmp"]}`

        File.delete(h["pathQrTmp"])

        $rqrCanvas.drawQr(@strLastQr)
        setCaption(tr("RQR"))
        @bNextQr = $rqrDialog.exec

        if @realZapMode then
          @pCont = Proc.new {
            execZapModeCont
          }
          startTimer(0)
        end
      }
      startTimer(0)
    end

  end

  def timerEvent(e)
    killTimers
    @pCont.call
  end

  def closeEvent(e)
    case QMessageBox::warning(self, tr("λƤ褤Ǥ"), tr("˽λƤǤ"), QMessageBox::Yes , QMessageBox::No)
    when QMessageBox::Yes
      h = $conf.getConf
      h["lastScreen"]=@tab.currentPageIndex.to_s
      $conf.setConf(h)
      e.accept
    when QMessageBox::No
      e.ignore
    end
  end
end

class RqrFileDialog < QDialog
  def initialize
    super(nil, "RqrFileDialog", true) # Modal Dialog
    setCaption(tr("¸ե̾"))
    vb=QVBox.new(self)
    vb.setFixedSize($env.defaultDialogSize,$env.defaultDialogSize)

    @dir = "/home/samba/Main_Memory"
    
    @dir.sub!(/\/usr\/mnt.rom\/cf/,"/home/samba/CF_Card")
    @dir.sub!(/\/usr\/mnt.rom\/card/,"/home/samba/SD_Card")
    if FileTest.directory?("/home/zaurus/") then
      @dir.sub!(/\/home\/zaurus\/Documents/,"/home/samba/Main_Memory")
    else
      @dir.sub!(/\/home\/root\/Documents/,"/home/samba/Main_Memory")
    end
    @dir.chomp!()
    @fname = ""

    @list = QListView.new(vb)
    if $env.largeScreen? then
      @list.addColumn("File Name",200)
      @list.addColumn("Size",50)
      @list.addColumn("DateTime",150)
    else
      @list.addColumn("File Name",90)
      @list.addColumn("Size",30)
      @list.addColumn("DateTime",80)
    end

    @list.setColumnAlignment(0,1)
    @list.setColumnAlignment(1,2)
    @list.setColumnAlignment(2,2)

    @f = Array.new()
    
    @le = QLineEdit.new(vb)
    
    connect( @list, QSIGNAL("returnPressed(QListViewItem*)"), self, 'selectFile')
  end

  def showDialog(df)
    @dir = File.dirname(df)
    @fname = File.basename(df)
    Dir.chdir(@dir)
    @le.setText(tr(@fname))
    showFiles
    exec
  end

  def showFiles
    @list.clear
    getDir
    i = 0
    setCaption(@dir)
    while i < @f.size
      fo = File.stat(@f[i])
      fs = fo.size / 1024
      fss = if fo.directory? then
              ""
            else
              fs.to_s + "Kb "
            end
      ft = fo.mtime.to_s
      li = QListViewItem.new(@list,@f[i],fss,ft)
      @list.setSelected(li, true) if @f[i] == @fname
      i += 1
    end
#    @fname = ""
  end

  def selectFile(selectedItem)
    sf = selectedItem.text(0).to_str
    if FileTest.directory?(sf)
      Dir.chdir(sf)
      @dir =Dir.pwd
      @dir = "/home/samba" if @dir == "/home/zaurus"
      @dir = "/home/samba" if @dir == "/mnt"
      @dir = "/home/samba" if @dir == "/usr/mnt.rom"
      Dir.chdir(@dir)
#      @fname = "."
      showFiles
    else
      @fname = sf
      @le.setText(tr(@fname))
    end
  end

  def getDir
    @f.clear
    @f = Dir.entries("./")
    @f.sort!
  end
  
  def getSelectedFile
    @dir + "/" + @fname
  end
end

class RqrMailDialog < QDialog
  def initialize
    super(nil, "RqrMailDialog", true) # Modal Dialog
    setCaption(tr("᡼륢ɥ쥹"))
    vb=QVBox.new(self)
    vb.setFixedSize($env.defaultDialogSize,$env.defaultDialogSize)
    QLabel.new(tr("ʣΥ᡼륢ɥ쥹ޤ\n򤷤Ƥ"),vb)
    @list = QListView.new(vb)
    @list.addColumn(tr("᡼륢ɥ쥹"))
#   Index
    @list.addColumn("",0)
    @astrMail = nil
  end

  def setMail(astrMail)
    @astrMail = astrMail
    @list.clear
    @astrMail.each_with_index do |e, i|
      QListViewItem.new(@list,tr(e),i.to_s)
    end
    @list.setSelected(@list.firstChild, true)
  end

  def getMail
    ret=@list.selectedItem.text(1).utf8.data
    if ret==nil then
       ""
    else
       @astrMail[ret.to_i]
    end
  end
end

class RqrAddressDialog < QDialog
  def initialize
    super(nil, "RqAddressDialog", true) # Modal Dialog
    setFixedSize($env.defaultDialogSize, $env.defaultDialogSize)
    @lvAdrs = QListView.new(self)
    @lvAdrs.setFixedSize(size)

    @lvAdrs.addColumn("Name",100)
    @lvAdrs.addColumn("Address",220)
    @lvAdrs.addColumn("",0)
    @lvAdrs.addColumn("",0)
    @lvAdrs.setSorting(2,true)

    @astrAdrs=nil

    @pCont=nil
    catchEvent
  end

  def ready?
    @astrAdrs!=nil
  end

  def makeList(bDialog = false)
    h=$conf.getConf
    bUseZdbat = false
    if FileTest.file?(h["pathAdrTmp"]) then
      if QMessageBox::warning(self,tr("åѤޤ"),tr("줿ɥ쥹ǡ\nå夬¸ߤޤ\nåѤ[Ϥ]\n٥ɥ쥹Ģ[]\n򤷤Ƥ"), QMessageBox::Yes , QMessageBox::No) == QMessageBox::No then
        bUseZdbat = true
      end
    else
        bUseZdbat = true
    end

    if bUseZdbat then
      setCaption(tr("ɥ쥹Ģ..."))
    else
      setCaption(tr("å夫..."))
    end

    @pCont = Proc.new {
      @astrAdrs = getAddresses(bUseZdbat)
      @lvAdrs.clear
      @astrAdrs.each_with_index do |n, i|
        QListViewItem.new(@lvAdrs,tr(n[2]+n[3]),tr(n[6]),tr(n[4]+n[5]),i.to_s)
      end
      @lvAdrs.setSelected(@lvAdrs.firstChild, true)
      setCaption(tr("򤷤Ƥ"))
    }
    if bDialog then
      startTimer(0)
    else
      @pCont.call
    end
  end

  def getAddresses(bUseZdbat)
    h=$conf.getConf
    if bUseZdbat then 
#                                    2    3    4    5    6    7    8    9    10   11   12   13   14   15 
      `#{$strZDBAT + " address -r -f LNME,FNME,LNPR,FNPR,MAL1,TEL1,CPS1,HWEB,HCTR,HZIP,HSTA,HCTY,HSTR,MEM1 > " + h["pathAdrTmp"]}`
    end

    csvAdrs = CSV::Reader.create(File.open(h["pathAdrTmp"],"r"))
    aStrAddress = nil
    csvAdrs.each do |row|
      if aStrAddress == nil then
        aStrAddress = Array.new
      else
        aOneAddress = Array.new
        row.each do |col|
          aOneAddress.push col.data
        end
        aStrAddress.push aOneAddress
      end
    end

    aStrAddress
  end

  def exec
    if !ready? then
      @pCont = Proc.new {
        makeList(true)
      }
      startTimer(0)
    end
    super
  end

  def timerEvent(e)
    killTimers
    @pCont.call
  end

  def addressMail
    ret=@lvAdrs.selectedItem
    if ret==nil then
       ""
    else
       @astrAdrs[ret.text(3).utf8.data.to_i][6]
    end
  end

  def addressAll
    ret=@lvAdrs.selectedItem
    if ret==nil then
       nil
    else
       @astrAdrs[ret.text(3).utf8.data.to_i]
    end
  end

  def eofAddress?
    @lvAdrs.selectedItem.itemBelow == nil
  end

  def nextAddressAll
    lv = @lvAdrs.selectedItem.itemBelow
    if lv != nil then
      @lvAdrs.setSelected(lv,true)
    end
    addressAll
  end

  def prevAddressAll
    lv = @lvAdrs.selectedItem.itemAbove
    if lv != nil then
      @lvAdrs.setSelected(lv,true)
    end
    addressAll
  end

end

a = QPEApplication.new([$0] + ARGV)

$env  = RqrEnv.new

if $env.largeScreen? then
  $iBlock=8
  $iFont=18
else
  $iBlock=4
  $iFont=10
end

QPEApplication.setFont(QFont.new("lcfont",$iFont))

a.setDefaultCodec(QTextCodec.codecForName("EUC-JP"))

if FileTest.directory?("/home/zaurus/") then
  $conf = RqrConf.new
else
  $conf = RqrConf.new("/home/root/Settings/rqr.conf")
end
if $strZDBAT!="" and $env.deviceName!="SL-A300" then
  $adrsDialog = RqrAddressDialog.new
end
$sizeDialog = RqrSetPixSizeDialog.new
$fileDialog = RqrFileDialog.new
$mailDialog = RqrMailDialog.new
$frmMain = FormMain.new
$rqrDialog = RqrDialog.new
$rqrCanvas = $rqrDialog.getCanvas
a.showMainWidget($frmMain)
a.exec
